:h2 res=1300.CDDB setup
Configure CDDB on this page. The current implementation does not support proxies.
You must have a direct connection to the internet.

Get more information by clicking on the links:
:sl.
:li.:link reftype=hd res=1301.Undo:elink.
:li.:link reftype=hd res=1302.Use CDDB/FREEDB:elink.
:li.:link reftype=hd res=1303.User Name:elink.
:li.:link reftype=hd res=1306.User Host:elink.
:li.:link reftype=hd res=1308.CDDB How To:elink.
:esl.





:h3 res=1301.Undo
:p.
Click on this button to discard the changes you've made.

:h3 res=1302. Use CDDB/FREEDB
:p.
Click on ths Button to enable the use of FREEDB or CDDB. You can sepcify on page 2 
the freedb server nearest to you. Make sure to insert your user name and host into
the entry fields.

:h3 res=1303.User name
:p.
This is your user name given to you by your provider or administrator. It's
the part before the :hp2.&atsign.:ehp2. of your mail address.

:p. 
The part after the :hp2.&atsign.:ehp2. of your mail address must be entered in the 
:link reftype=hd res=1306.User host:elink. entry field.

:h3 res=1306.User Host
:p.
Specifies the Host for which you have an account. This is the part of your
mail address after the :hp2.&atsign.:ehp2..
:p.
The part before the :hp2.&atsign.:ehp2. of your mail address must be entered in the 
:link reftype=hd res=1303.User name:elink. entry field.



:h2 res=1307.CDDB server setup
If you decide not to use the already configured FREEDB you have to insert 
here the servers and the ports to access the CDDB information (e.g. 
de.freedb.org&colon.888 for the german freedb mirror on port 888). You can also add
a News Server e.g. news.cis.dfn.de. Get an account here http&colon.//news.cis.dfn.de/
:p.
If a server does not deliver the requested information, the next server in the
list will be queried. So if you have a preferred server put it at the top of the list.



:h2 res=1308.CDDB How To
- WHAT IS THE CDDB
.br
- CDDB USE RESTRICTIONS
.br
- ACCESS TO THE CDDB
.br
- CDDB DISCID
.br
- REMOTE CDDB ACCESS
.br
:p.
WHAT IS THE CDDB
.br
CDDB (CD database) is an information database containing artist, disc 
title, track titles, and other information for digital audio compact 
discs. Over time, this archive has grown to contain a substantial 
collection of CD information and is continuing to grow at a rapid rate. 
This database can be accessed by applications via the CDDB server hosts 
that have been set up on the Internet around the world.
:p.
The CDDB data format and the CDDB servers are designed to be open, and 
are used by many client applications requiring CD information. CDDB has 
become the de facto standard for Internet access of compact disc 
information.
:p.
CDDB USE RESTRICTIONS
.br
Users of CDDB-capable freeware and shareware applications may use the 
public CDDB servers for free. Commercial uses of CDDB data and/or servers 
are subject to negotiations with CDDB Inc. Please write to us at 
licensing@cddb.com for more information.
:p.
If you plan to use CDDB and/or the CDDB servers in your software, please 
notify support@cddb.com of your intent. Also, we appreciate that you 
keep us posted as to your development/test progress and release schedules. 
Before you release your CDDB application we must verify that it properly 
implements the CDDB functionality. You must provide us with a copy of your 
software for testing when it is ready. Please do not release your software 
with CDDB functionality until it has been tested.
:p.
You must explicitly give credit to CDDB, Inc. in your application, both in 
all documentation that mentions the CDDB functionality in any way, and when 
the product is operating. The exact details should be obtained from 
licensing@cddb.com before you release your software.
:p.
ACCESS TO THE CDDB
.br
Remote access
.br
In this mode the software must connect to a CDDB server on the 
network to access the CDDB.  There is a CDDB server protocol that 
the software (also known as the "client") must use to converse with 
the server.
:p.
This mode allows the client application full access to the entire 
CD database over the Internet.
:p.
You may choose to support only remote access mode, or both remote and 
local. We do not recommend a local-only application, since it is not 
very useful.
:p.
CDDB DISCID
.br
Both forms of CDDB access require that the software compute a "disc 
ID" which is an identifier that is used to access the CDDB.  The disc 
ID is a 8-digit hexadecimal (base-16) number, computed using data from 
a CD's Table-of-Contents (TOC) in MSF (Minute Second Frame) form.
:p.
REMOTE CDDB ACCESS
.br
In order to perform remote access of CDDB servers, your software must be 
able to communicate with a remote CD server system via HTTP. There are a 
number of public CDDB servers operating on the Internet. The current list 
of public servers may be obtained programmatically via the CDDB protocol 
"sites" command. The permanent server site, cddb.cddb.com has been 
established in order to provide a reliable source of server site information 
via the "sites" command. This address may be safely hard-wired into client 
software for this purpose, as it is guaranteed to exist on a permanent basis. 
Furthermore, the "cddb.cgi" program is guaranteed to always reside at the 
following path: /~cddb/cddb.cgi
:p.
Thus, the URL for accessing the server at cddb.cddb.com is:
:p.
http&colon.//cddb.cddb.com/~cddb/cddb.cgi
:p.
Make sure to use the proper arguments in the "hello=" command. The user 
and hostname arguments should be that of the user's email address, not 
some fixed hard-coded value. The application name and version should be 
that of your application, not that of another existing application.
:p.
We consider the use of the "cddb query" command mandatory for all CDDB 
clients. It is not valid to issue a "cddb read" command without issuing 
a prior "cddb query" and receiving a good response, as it may yield incorrect 
results. In addition, it is required that clients support close matches 
(aka "fuzzy" matches, or response code 211) and multiple exact matches 
(response code 210) in response to a query.
:p.
The proper way to handle multiple exact/fuzzy matches is to present the 
entire list of matches to the user and to let the user choose between them. 
Matches are listed in the order of best fit for the user's disc, so they 
should be presented to the user in the order they are listed by the server. 
:p.




